<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductResultInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfProductResultInsert extends AbstractStructArrayBase
{
    /**
     * The ProductResultInsert
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductResultInsert[]
     */
    public $ProductResultInsert;
    /**
     * Constructor method for ArrayOfProductResultInsert
     * @uses ArrayOfProductResultInsert::setProductResultInsert()
     * @param \StructType\ProductResultInsert[] $productResultInsert
     */
    public function __construct(array $productResultInsert = array())
    {
        $this
            ->setProductResultInsert($productResultInsert);
    }
    /**
     * Get ProductResultInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductResultInsert[]|null
     */
    public function getProductResultInsert()
    {
        return isset($this->ProductResultInsert) ? $this->ProductResultInsert : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductResultInsert method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductResultInsert method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductResultInsertForArrayConstraintsFromSetProductResultInsert(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductResultInsertProductResultInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductResultInsertProductResultInsertItem instanceof \StructType\ProductResultInsert) {
                $invalidValues[] = is_object($arrayOfProductResultInsertProductResultInsertItem) ? get_class($arrayOfProductResultInsertProductResultInsertItem) : sprintf('%s(%s)', gettype($arrayOfProductResultInsertProductResultInsertItem), var_export($arrayOfProductResultInsertProductResultInsertItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductResultInsert property can only contain items of type \StructType\ProductResultInsert, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductResultInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductResultInsert[] $productResultInsert
     * @return \ArrayType\ArrayOfProductResultInsert
     */
    public function setProductResultInsert(array $productResultInsert = array())
    {
        // validation for constraint: array
        if ('' !== ($productResultInsertArrayErrorMessage = self::validateProductResultInsertForArrayConstraintsFromSetProductResultInsert($productResultInsert))) {
            throw new \InvalidArgumentException($productResultInsertArrayErrorMessage, __LINE__);
        }
        if (is_null($productResultInsert) || (is_array($productResultInsert) && empty($productResultInsert))) {
            unset($this->ProductResultInsert);
        } else {
            $this->ProductResultInsert = $productResultInsert;
        }
        return $this;
    }
    /**
     * Add item to ProductResultInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductResultInsert $item
     * @return \ArrayType\ArrayOfProductResultInsert
     */
    public function addToProductResultInsert(\StructType\ProductResultInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductResultInsert) {
            throw new \InvalidArgumentException(sprintf('The ProductResultInsert property can only contain items of type \StructType\ProductResultInsert, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductResultInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductResultInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductResultInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductResultInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductResultInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductResultInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductResultInsert
     */
    public function getAttributeName()
    {
        return 'ProductResultInsert';
    }
}
